pro Get_Files, Event, imode
	;
	;	gets the input files
	;
	;	imode = 0 launches file chooser
	;	imode = 1 says files are on the m_ptr structure
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	m_ptr = PTR_struct.PTR_main
	;
	;	the other mode - 0 if file chooser used to get CDS_RAW files,
	;					  1 (not here) if file chooser selected PCATs
	;
	(*m_ptr).mode = 0L
	;
	;	clear all LEDs, if manual mode
	;
	if(imode eq 0) then begin
	  	is_wid = (*m_ptr).draw_wid[4]
	  	is_not_wid = (*m_ptr).draw_wid[5]
	  	ZHT_led_stack, is_wid, ["gray"]
	  	ZHT_led_stack, is_not_wid, ["gray"]
	  	;
	  	ZHT_led_stack, (*m_ptr).draw_wid[7], ["gray"]
	  	ZHT_led_stack, (*m_ptr).draw_wid[6], ["gray"]
  	endif
	;
	;	and plots, if manual mode
	;
	if(imode eq 0) then begin
	  	draw_wid_0 = (*m_ptr).draw_wid[0]
	  	WIDGET_CONTROL, draw_wid_0, GET_VALUE=win_no_0
	  	wset, win_no_0
	  	erase
	  	draw_wid_1 = (*m_ptr).draw_wid[1]
	  	WIDGET_CONTROL, draw_wid_1, GET_VALUE=win_no_1
	  	wset, win_no_1
	  	erase
	  	draw_wid_2 = (*m_ptr).draw_wid[2]
	  	WIDGET_CONTROL, draw_wid_2, GET_VALUE=win_no_2
	  	wset, win_no_2
	  	erase
	  	draw_wid_3 = (*m_ptr).draw_wid[3]
	  	WIDGET_CONTROL, draw_wid_3, GET_VALUE=win_no_3
	  	wset, win_no_3
	  	erase
	  	draw_wid_8 = (*m_ptr).draw_wid[8]
	  	WIDGET_CONTROL, draw_wid_8, GET_VALUE=win_no_8
	  	wset, win_no_8
	  	erase
	  	draw_wid_9 = (*m_ptr).draw_wid[9]
	  	WIDGET_CONTROL, draw_wid_9, GET_VALUE=win_no_9
	  	wset, win_no_9
	  	erase
  	endif
	;
	;	and desensitize the "basic analysis button"
	;
	if(imode eq 0) then WIDGET_CONTROL, (*m_ptr).button_wid[1], SENSITIVE=0
	;
	;	and clear the textboxes
	;
	for itext = 0, 5 do begin
		WIDGET_CONTROL, (*m_ptr).text_wid[itext], SET_VALUE=' '
	endfor
	;
	if(imode eq 0) then begin
		search_path = (*m_ptr).last_dir
		filter = '*.fits'
		;zprint_text, Event, "opening "+search_file
		;
		files_in = dialog_pickfile(Title="Select Files",/multiple_files,PATH=search_path,FILTER=filter)
	endif else begin
		nf = (*m_ptr).nf
		files_in = (*m_ptr).input_files[0:(nf-1)]
	endelse
	;
	nfiles = N_ELEMENTS(files_in)
	if(nfiles lt 3) then begin
		zprint_text, Event, "ERROR - too few files selected"
		goto, the_end
	endif
	;
	;	sort the file names
	;
	ind_sort = SORT(files_in)
	files_in = files_in[ind_sort]
	;
	(*m_ptr).n_files_in = nfiles
	(*m_ptr).files_in[0:nfiles-1] = files_in[*]
	(*m_ptr).sub_flag = -1
	(*m_ptr).n_sub_files = 0
	WIDGET_CONTROL, (*m_ptr).base_orig_wid, SENSITIVE=0
	;
	zprint_text, Event, "Selected "+STRING(nfiles)+" files for analysis"
	;
	;	deconstruct night name
	;
	first_image = FILE_BASENAME(files_in[0],'.fits',/FOLD_CASE)
	last_image = FILE_BASENAME(files_in[N_ELEMENTS(files_in)-1],'.fits',/FOLD_CASE)
	ind_dot = STRPOS(first_image,'.')
	if(ind_dot ne -1) then begin
		night_desig = STRMID(first_image,0,ind_dot)
		;
		ind_underscore = STRPOS(first_image, '_')
		if(ind_underscore ne -1) then begin
			starting_image = STRMID(first_image,ind_dot+1,(ind_underscore - ind_dot - 1))
			ending_image = STRMID(last_image, ind_dot+1, (ind_underscore - ind_dot - 1))
		endif else begin
			starting_image = STRMID(first_image, ind_dot+1)
			ending_image = STRMID(last_image, ind_dot+1)
		endelse
	endif else begin
		night_desig = '??'
		starting_image = '??'
		ending_image = '??'
	endelse
	;
	header = headfits(files_in[0])
	field_name = SXPAR(header, 'OBJECT',COUNT=count)
	if(count ne 1) then field_name = '??'
	;
	WIDGET_CONTROL, (*m_ptr).text_wid[2], SET_VALUE=field_name
	(*m_ptr).outfile = field_name
	WIDGET_CONTROL, (*m_ptr).text_wid[3], SET_VALUE=night_desig
	WIDGET_CONTROL, (*m_ptr).text_wid[4], SET_VALUE=starting_image
	WIDGET_CONTROL, (*m_ptr).text_wid[5], SET_VALUE=ending_image
	;
	;	next, test for the presence of a key subdirectory
	;
	test_dir = FILE_DIRNAME(files_in[0]) + PATH_SEP() + 'Original_pol_images'
	;
	;print, "test_dir = ",test_dir
	;
	test_this = FILE_INFO(test_dir)
	;
	;print, "test_this ", test_this
	;help, test_this, /struct
	;
	if(test_this.exists and test_this.directory) then begin
		;
		;	subdirectory is present - look for any files matching any of those on the list
		;
		zprint_text, Event, "Found an originals subdirectory - testing for file name matches"
		sub_list = FILE_SEARCH(test_dir+ PATH_SEP() + "*.*")
		n_sub = N_ELEMENTS(sub_list)
		if(n_sub eq 0) then begin
			zprint_text, Event, "Subdirectory was empty. Processing continues"
			goto, no_sub
		endif
		zprint_text, Event, "Subdirectory had "+STRING(n_sub)+" files. Checking for matches"
		;
		;	look for matching images
		;
		use_flag = -1
		sub_match = strarr(nfiles)
		nsub_match = 0L
		for i_in = 0, nfiles-1 do begin
			;
			ind_this = WHERE(FILE_BASENAME(files_in[i_in]) eq FILE_BASENAME(sub_list),nmatch)
			if(nmatch gt 0) then begin
				;
				;	if use_flag not yet set or reset, then turn on base and light up buttons
				;
				if(use_flag eq -1) then begin
					WIDGET_CONTROL, (*m_ptr).base_orig_wid, SENSITIVE=1
					;
					WIDGET_CONTROL, (*m_ptr).button_wid[3], SENSITIVE=1
					WIDGET_CONTROL, (*m_ptr).button_wid[4], SENSITIVE=1
				endif
				;
				;	got a match, save it
				;
				sub_match[nsub_match] = sub_list[ind_this[0]]
				nsub_match++
			endif
		endfor
		;
		zprint_text, Event, "Found "+STRING(nsub_match)+" matches"
		;
		;	test for number of matches, if none, continue processing
		;
		if(nsub_match eq 0) then begin
			zprint_text, Event, "No matches, so normal processing"
			goto, no_sub
		endif
		;
		;	otherwise, save results and set flag
		;
		(*m_ptr).n_sub_files = nsub_match
		(*m_ptr).sub_files[0:nsub_match-1] = sub_match[0:nsub_match-1]
		(*m_ptr).sub_flag = 1L
	endif
	;
	;	else, continue processing
	;
	no_sub:
	;
	process_images, Event
	;
	;	exit
	;
	the_end:
	WIDGET_CONTROL, (*m_ptr).button_wid[1], SENSITIVE=1
end
