pro get_ppol_header_values
;
;	harvests PPOL headers for key info, puts data into data file
;
;	DPC	20160929
;
dir = dialog_pickfile(title='select GPIPS DR PPOL directory',/dir)
;
out_file = dialog_pickfile(title='Output File Name')
;
openw, lu_out, out_file, /get_lun
;
for i = 0, 3236 do begin
	;
	filename = dir + 'GP' + string(i+1,format='(i4.4)') + '_POLCAT.dat'
	;
	;	test for its presence
	;
	test = FILE_INFO(filename)
	;
	if(test.exists eq 0) then begin
		;
		printf, lu_out, i+1, format='("GP",i4.4,2x,"0.000  0.000  0.000  0.000  ")'
		;
	endif else begin
		;
		;	get info from file
		;
		str = read_polcat(filename)
		;
		;	get first, last images and parse the names
		;
		first = str.pol_head.image_0
		parts = STRSPLIT(first,'.',/extract)
		night = parts[0]
		nch = STRLEN(parts[1])
		first_image = STRMID(parts[1],0,nch-5)
		last = str.pol_head.image_n
		parts2 = STRSPLIT(last,'.',/extract)
		nch2 = STRLEN(parts2[1])
		last_image = STRMID(parts2[1],0,nch2-5)
		;
		n_in_group = str.pol_head.n_in_grp
		n_use0 = str.pol_head.n_use_0
		;
		if(i eq 0) then begin
			printf, lu_out, '  GP#     SN     FP    sFP    RMS     CalDate      Night   First  Last Nobs Nuse0 PPOLver ProcessDt'
			printf, lu_out, '----------------------------------------------------------------------------------------------------'
		endif
		printf, lu_out, i+1, str.pol_head.skynoise, str.pol_head.fieldpol, str.pol_head.noise_fp, $
							 str.pol_head.rms_cor, str.pol_head.datestmp, night, first_image, last_image, $
							 n_in_group, n_use0, $
							 str.pol_head.ppol_ver, $
							 str.pol_head.process_dt, $
							format='("GP",i4.4,2x,4(f5.3,2x),f12.2,2x,a8,2x,i4,2x,i4,2x,i3,2x,i3,2x,a,2x,a)'
	endelse
	;
endfor
;
free_lun, lu_out
;
print, "done!"
end
