pro process_GPIPS_DR3, Event
;
;	oversees the execution of ZHT for the full GPIPS DR3 data set
;
WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
m_ptr = PTR_struct.PTR_main
;
;	recover the two save files
;
; first, get pathname to the directory with the files
;
files_dir = dialog_pickfile(title='Select Directory Hosting GPIPS DR3 SAV files',/dir)
;
restore, filename=files_dir + 'GPIPS_DR3_summary_dates_and_image_numbers.sav'
restore, filename=files_dir + 'GPIPS_dates_and_paths_to_CDS_files.sav'
;
;	for each GP field,
;
for igp = 563, 3236 do begin
;10 do begin
;3236 do begin
	;
	;	get field number and look up the night
	;
	this_gp = gp_num[igp]
	this_night = gp_night[igp]
	this_first = gp_im0[igp]
	this_last = gp_im1[igp]
	;
	;	get the data directory path
	;
	ind = WHERE(dates eq this_night, nmatch)
	;
	if(nmatch eq 0) then begin
		zprint_text, Event, 'No night match for  GP'+STRING(this_gp,format='(i4)')
		goto, loop_end
	endif
	;
	this_path = paths[ind[0]] + 'CDS_RAW' + PATH_SEP()
	;
	;	construct the list of files
	;
	(*m_ptr).nf = 0
	;
	for ifile = this_first, this_last do begin
		;
		;	construct filepath name and then check that it is present
		;
		if(ifile lt 1000) then begin
			this_pathname = this_path + STRING(this_night,ifile,format='(I8,".",I3,".fits")')
		endif else begin
			this_pathname = this_path + STRING(this_night,ifile,format='(I8,".",I4,".fits")')
		endelse
		;
		result = FILE_TEST(this_pathname)
		if(result eq 1) then begin
			;
			(*m_ptr).input_files[(*m_ptr).nf] = this_pathname
			(*m_ptr).nf++
		endif
	endfor
	;
	;	go get the files and populate the GUI, if the number of input files is non-zero
	;
	if((*m_ptr).nf gt 0) then begin
  	get_files, event, 1							; 1 says get filenames from m_ptr
  	;
  	;
  	;	and run the analyzer
  	;
  	start_analysis, event
  	;
  	;	done - go on to next file after checking the single - step flag
  	;
  	if( (*m_ptr).single_step eq 1L) then begin
  		result = dialog_message('Press OK for Next Field',/INFORMATION)
  	endif
  	;
  endif else begin
      print, 'No files for GP',this_gp,' so skipping it'
      print, ' night = ',this_night,' first, last = ',this_first, this_last
      ;
  endelse
	loop_end:
endfor
;
;	completed, return
;
end